<app-loading *ngIf="isLoading"></app-loading>
<div nz-col nzSpan="12" class="btn-import-permission">
  <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="syncPermission()"
             [mbButtonIsLoading]='isSyncPermission' [mbIsDisable]='isSyncPermission'
             mbButtonAvailableStyle="LOADING" mbButtonText="{{'system.userPermissionConfig.attributes.syncPermissionResourceFromKeycloak' | translate}}"></mb-button>
  <mb-button mbButtonSize="MEDIUM" *ngIf="objFunction?.import"
             mbButtonText="{{'common.button.uploadFile' | translate}}"
             mbButtonTextColor="#141ED2" (click)="doImportData()"></mb-button>
  <mb-button mbButtonType="BORDER" mbButtonSize="MEDIUM" (click)="doExportData()">
    <img src="assets/images/icon/excel.svg" alt="" />
  </mb-button>
</div>
<div nz-row class="content">
  <div nz-col nzSm='24' nzLg='12'>
    <div class="app-card">
      <div class="container-fluid" nz-col nzSpan="24">
        <div class="form">
          <div nz-row class="form-row">
            <div nz-col nzSm='12' nzLg='15' class="form-row__left">
              <input nz-input class="form-row__input" name="" placeholder="{{'common.label.search' | translate}}"
                     [(ngModel)]="params.search" trim (keyup.enter)="searchRole()"/>
              <mb-button class="center" mbButtonType="NO_BORDER" mbButtonSize="VERY_LARGE" (click)="searchRole()"
                         mbButtonAvailableStyle="SEARCH"
                         mbButtonText="{{'common.label.search' | translate}}"></mb-button>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="app-list">
      <div class="data-table" oncontextmenu="return false;">
        <nz-table #basicTable [nzData]="listRole" [nzShowPagination]="false" nzSize='small'
                  [nzScroll]="listRole.length > 10 ? { y: '530px' } : {}" [nzPageSize]="pageSize">
          <thead>
          <tr class="table-header">
            <th scope="col" nzWidth="50px" class="text-nowrap text-center">{{'system.table.stt' | translate}}</th>
            <th scope="col" class="text-nowrap">{{'system.role.label.table.code' | translate}}</th>
            <th scope="col" class="text-nowrap">{{'system.role.label.table.name' | translate}}</th>
          </tr>
          </thead>
          <tbody>
          <tr *ngFor="let data of basicTable.data ;let i = index; trackBy: trackByRole" (click)="onSelect(data)"
              class='row-table'
              [ngClass]="{ 'activeRow': roleCodeSelected === data.name}">
            <td
              class="text-center">{{validateService.getRowIndex(i, pageable?.currentPage, basicTable.nzPageSize)}}</td>
            <td>{{ data?.name }}</td>
            <td>{{ data?.description }}</td>
          </tr>
          </tbody>
        </nz-table>
      </div>
    </div>
    <div class="pagination" nz-row *ngIf='listRole && listRole.length > 0'>
      <div nz-col nzLg="24" nzMd='24' nzXl='24' nzXXl='11'>
        <img class="pagination__table-info--icon" alt="" src="assets/images/icon/idea.svg">
        <span class="pagination__table-info--text">
            Tìm thấy {{pageable.totalElements}} kết quả, hiển thị từ
          {{(pageable.size * (pageable.currentPage - 1)) + 1}}
          đến {{(pageable.size * (pageable.currentPage - 1)) + pageable.numberOfElements}}
          </span>
      </div>
      <nz-pagination nz-col nzLg="24" nzMd='24' nzXl='24' nzXXl='13'
                     [(nzPageIndex)]="pageable.currentPage" [nzTotal]="pageable.totalElements"
                     [nzPageSize]="pageable.size" (nzPageIndexChange)="searchRole($event)" class="pagination__icon">
      </nz-pagination>
    </div>
  </div>
  <div nz-col nzSm='24' nzLg='12'>
    <div class="app-card">
      <div class="container-fluid" nz-col nzSpan="24">
        <div class="form">
          <div nz-row class="form-row">
            <div nz-col nzSm='12' nzLg='12'>
              <mb-select [mbDataSelects]="listApp" mbKeyLabel="name" mbKeyValue="id"
                         mbPlaceholder="--{{'system.permissionForRole.label.all' | translate}}--"
                         (mbEventEmit)="changeApp(false)"
                         [(ngModel)]="idApp"></mb-select>
            </div>
            <div nz-col nzSm='12' nzLg='12' class="form-row__right" *ngIf="objFunction.edit">
              <label nz-checkbox [(ngModel)]="isCheckedAll" (ngModelChange)="checkAll($event)"
                     [disabled]="listOfMap.length === 0"> {{'system.permissionForRole.label.checked' | translate}} </label>
              <mb-button mbButtonType="NO_BORDER" mbButtonSize="VERY_LARGE" (click)="save()"
                         [mbIsDisable]="!roleCodeSelected || !idApp || listOfMap.length === 0"
                         mbButtonAvailableStyle="PRIMARY"
                         mbButtonText="{{'common.button.saveS' | translate}}"></mb-button>
            </div>
          </div>
        </div>
      </div>
    </div>
    <div class="app-list">
      <div class="data-table" oncontextmenu="return false;">
        <nz-table #tableTree [nzData]="listOfMap" [nzShowPagination]="false" nzSize='small'
                  nzTableLayout="fixed" [nzScroll]="{ y: '530px' }" [nzPageSize]="listOfMap.length">
          <thead>
          <tr class="table-header">
            <th scope="col" nzWidth="80%"
                class="text-nowrap">{{'system.permissionForRole.table.label.name' | translate}}</th>
            <th scope="col" nzWidth="20%"
                class="text-nowrap text-center">{{'system.permissionForRole.table.label.type' | translate}}</th>
          </tr>
          </thead>
          <tbody>
          <ng-container *ngFor="let data of tableTree.data">
            <ng-container *ngFor="let item of mapOfExpanded[data.key]; trackBy: trackByNode">
              <tr class='row-table' *ngIf="(item.parent && item.parent.expand) || !item.parent">
                <td
                  [nzIndentSize]="item.level! * 20"
                  [(nzExpand)]="item.expand"
                  (nzExpandChange)="collapses(mapOfExpanded[data.key], item, $event)"
                >
                  <label nz-checkbox [(ngModel)]="item.checked" [disabled]="!objFunction.edit"
                         (ngModelChange)="onChangeCheckbox(mapOfExpanded[data.key], item, $event)"> </label>
                  {{ item.name }}
                </td>
                <td class="text-center">{{ item.type }}</td>
              </tr>
            </ng-container>
          </ng-container>
          </tbody>
        </nz-table>
      </div>
    </div>
  </div>
</div>
<mb-import [showContent]='isImportData'
           (onCloseModal)='doCloseImport($event)'
           [urlApiDownloadTemp]='urlApiDownloadTemp'
           [urlApiImport]='urlApiImport'>
</mb-import>
